package com.hungraim.ltc.system.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.hungraim.ltc.constant.AuthConstants;
import com.hungraim.ltc.pojo.entity.system.SystemInterface;
import com.hungraim.ltc.system.dao.SystemInterfaceMapper;
import com.hungraim.ltc.system.service.ISystemInterfaceService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class SystemInterfaceServiceImpl extends ServiceImpl<SystemInterfaceMapper, SystemInterface> implements ISystemInterfaceService {

    private final SystemInterfaceMapper systemInterfaceMapper;

    private final RedisTemplate redisTemplate;

    @Autowired
    public SystemInterfaceServiceImpl(SystemInterfaceMapper systemInterfaceMapper, RedisTemplate redisTemplate) {
        this.systemInterfaceMapper = systemInterfaceMapper;
        this.redisTemplate = redisTemplate;
    }

    @Override
    public void refreshResourceInterfaceCache() {
        try{
            redisTemplate.delete(AuthConstants.PERMISSION_ROLES_interface_KEY);
            Map<String, List<String> > map = new HashMap<>();
            List<Long> interfaceIds = systemInterfaceMapper.listRI();
            for (Long interfaceId:interfaceIds){
                List<String> systemInterfaces = this.listResourceInterface(interfaceId);
                map.put(interfaceId.toString(),systemInterfaces);

            }
            redisTemplate.opsForHash().putAll(AuthConstants.PERMISSION_ROLES_interface_KEY, map);
        }catch (RuntimeException e){
            e.printStackTrace();
        }
    }

    @Override
    public List<String> listResourceInterface(Long interfaceId) {
        return systemInterfaceMapper.listInterface(interfaceId);
    }
}
